#include "CoinPragma.hpp"

#include <math.h>

#include "CoinHelperFunctions.hpp"
#include "ClpSimplex.hpp"
#include <cfloat>
// This sections needs to match Clp_C_defines.h but with extern C
// this is duplicated from Clp_C_Interface.cpp. Not cool.

#define ClpSimplexCDefine_H


/** This has #defines etc for the "C" interface to Clp.

*/

/* Plus infinity */
#ifndef COIN_DBL_MAX
#define COIN_DBL_MAX DBL_MAX
#endif

/* We need to allow for Microsoft */
#ifndef CLPLIBAPI

#if defined (CLPMSDLL)
#   define CLPLIBAPI __declspec(dllexport) extern "C"
#   define CLPLINKAGE  __stdcall
#   define CLPLINKAGE_CB  __cdecl
#else
#   define CLPLIBAPI extern "C"
#   define CLPLINKAGE
#   define CLPLINKAGE_CB 
#endif

#endif
class CMessageHandler;

typedef struct {
  ClpSimplex * model_;
  CMessageHandler * handler_;
} Clp_Simplex;

typedef  void (CLPLINKAGE_CB *clp_callback) (Clp_Simplex * model,int  msgno, int ndouble,
                            const double * dvec, int nint, const int * ivec,
                            int nchar,  char ** cvec);


#include "Clp_C_Extra.h"


    /** Write the problem in MPS format to the specified file.

	Row and column names may be null.
	formatType is
	<ul>
	  <li> 0 - normal
	  <li> 1 - extra accuracy 
	  <li> 2 - IEEE hex (later)
	</ul>

	Returns non-zero on I/O error
    */

CLPLIBAPI int CLPLINKAGE Clp_writeMps(Clp_Simplex *model, 
				       const char *filename,
				       int formatType,
				       int numberAcross,
				       double objSense){
  return model->model_->writeMps(filename,formatType,numberAcross, objSense);
}
