/**
 * @file   ine.lex
 * @author David Bremner
 * @date   Fri Apr 19 16:35:15 2002
 * 
 * @brief  A simple scanner to read variations on lrs/cdd INE filws
 * 
 * 
 */

%{
#include "inescan.h"
  long int ineint;
  long int ineline=0;
%}
D [0-9]
%%
{D}+	{ ineint=atol(inetext); return INE_INT; }
begin { return INE_BEGIN; }
end   { return INE_END; }
"\n"	{ ineline++; return INE_EOL; }
[ \t]+          /* eat up whitespace */
.       { return inetext[0]; } 
<<EOF>> { return INE_EOF; }
%%

inewrap(){
  return 1;
}
